package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.LivingEntity;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.model.HorseModel;
import net.minecraft.world.entity.animal.horse.AbstractHorse;

public abstract class AbstractHorseRenderer<T extends AbstractHorse, M extends HorseModel<T>> extends MobRenderer<T, M> {
    private final float scale;
    
    public AbstractHorseRenderer(final EntityRenderDispatcher dvf, final M dlh, final float float3) {
        super(dvf, dlh, 0.75f);
        this.scale = float3;
    }
    
    @Override
    protected void scale(final T aue, final PoseStack cyl, final float float3) {
        cyl.scale(this.scale, this.scale, this.scale);
        super.scale(aue, cyl, float3);
    }
}
