package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.Entity;
import net.minecraft.client.renderer.entity.layers.ItemInHandLayer;
import net.minecraft.client.renderer.entity.layers.ElytraLayer;
import net.minecraft.client.renderer.entity.layers.RenderLayer;
import net.minecraft.client.renderer.entity.layers.CustomHeadLayer;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.HumanoidModel;
import net.minecraft.world.entity.Mob;

public class HumanoidMobRenderer<T extends Mob, M extends HumanoidModel<T>> extends MobRenderer<T, M> {
    private static final ResourceLocation DEFAULT_LOCATION;
    
    public HumanoidMobRenderer(final EntityRenderDispatcher dvf, final M dlj, final float float3) {
        super(dvf, dlj, float3);
        this.addLayer(new CustomHeadLayer<T, M>(this));
        this.addLayer(new ElytraLayer<T, M>(this));
        this.addLayer(new ItemInHandLayer<T, M>(this));
    }
    
    @Override
    public ResourceLocation getTextureLocation(final T ala) {
        return HumanoidMobRenderer.DEFAULT_LOCATION;
    }
    
    static {
        DEFAULT_LOCATION = new ResourceLocation("textures/entity/steve.png");
    }
}
