package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.LivingEntity;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.entity.layers.RenderLayer;
import net.minecraft.client.renderer.entity.layers.CustomHeadLayer;
import net.minecraft.client.model.IllagerModel;
import net.minecraft.world.entity.monster.AbstractIllager;

public abstract class IllagerRenderer<T extends AbstractIllager> extends MobRenderer<T, IllagerModel<T>> {
    protected IllagerRenderer(final EntityRenderDispatcher dvf, final IllagerModel<T> dlk, final float float3) {
        super(dvf, dlk, float3);
        this.addLayer(new CustomHeadLayer<T, IllagerModel<T>>(this));
    }
    
    @Override
    protected void scale(final T awe, final PoseStack cyl, final float float3) {
        final float float4 = 0.9375f;
        cyl.scale(0.9375f, 0.9375f, 0.9375f);
    }
}
