package net.minecraft.network.syncher;

public class EntityDataAccessor<T> {
    private final int id;
    private final EntityDataSerializer<T> serializer;
    
    public EntityDataAccessor(final int integer, final EntityDataSerializer<T> sc) {
        this.id = integer;
        this.serializer = sc;
    }
    
    public int getId() {
        return this.id;
    }
    
    public EntityDataSerializer<T> getSerializer() {
        return this.serializer;
    }
    
    @Override
    public boolean equals(final Object object) {
        if (this == object) {
            return true;
        }
        if (object == null || this.getClass() != object.getClass()) {
            return false;
        }
        final EntityDataAccessor<?> sb3 = object;
        return this.id == sb3.id;
    }
    
    @Override
    public int hashCode() {
        return this.id;
    }
    
    @Override
    public String toString() {
        return "<entity data: " + this.id + ">";
    }
}
