package net.minecraft.realms;

import com.google.common.collect.UnmodifiableIterator;
import com.mojang.blaze3d.vertex.VertexFormatElement;
import com.google.common.collect.Lists;
import java.util.List;
import com.mojang.blaze3d.vertex.VertexFormat;

public class RealmsVertexFormat {
    private VertexFormat v;
    
    public RealmsVertexFormat(final VertexFormat cyp) {
        this.v = cyp;
    }
    
    public VertexFormat getVertexFormat() {
        return this.v;
    }
    
    public List<RealmsVertexFormatElement> getElements() {
        final List<RealmsVertexFormatElement> list2 = Lists.newArrayList();
        for (final VertexFormatElement cyq4 : this.v.getElements()) {
            list2.add(new RealmsVertexFormatElement(cyq4));
        }
        return list2;
    }
    
    @Override
    public boolean equals(final Object object) {
        return this.v.equals(object);
    }
    
    @Override
    public int hashCode() {
        return this.v.hashCode();
    }
    
    @Override
    public String toString() {
        return this.v.toString();
    }
}
