package net.minecraft.server;

import net.minecraft.server.dedicated.DedicatedServerProperties;

public interface ServerInterface {
    DedicatedServerProperties getProperties();
    
    String getServerIp();
    
    int getServerPort();
    
    String getServerName();
    
    String getServerVersion();
    
    int getPlayerCount();
    
    int getMaxPlayers();
    
    String[] getPlayerNames();
    
    String getLevelIdName();
    
    String getPluginNames();
    
    String runCommand(final String string);
    
    boolean isDebugging();
    
    void info(final String string);
    
    void warn(final String string);
    
    void error(final String string);
    
    void debug(final String string);
}
