package net.minecraft.world.inventory;

import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.Container;

public class FurnaceFuelSlot extends Slot {
    private final AbstractFurnaceMenu menu;
    
    public FurnaceFuelSlot(final AbstractFurnaceMenu bao, final Container aje, final int integer3, final int integer4, final int integer5) {
        super(aje, integer3, integer4, integer5);
        this.menu = bao;
    }
    
    @Override
    public boolean mayPlace(final ItemStack ben) {
        return this.menu.isFuel(ben) || isBucket(ben);
    }
    
    @Override
    public int getMaxStackSize(final ItemStack ben) {
        return isBucket(ben) ? 1 : super.getMaxStackSize(ben);
    }
    
    public static boolean isBucket(final ItemStack ben) {
        return ben.getItem() == Items.BUCKET;
    }
}
