package net.minecraft.world.item;

import net.minecraft.stats.Stat;
import net.minecraft.stats.Stats;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.ThrownEgg;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;

public class EggItem extends Item {
    public EggItem(final Properties a) {
        super(a);
    }
    
    @Override
    public InteractionResultHolder<ItemStack> use(final Level bjw, final Player ayj, final InteractionHand ajk) {
        final ItemStack ben5 = ayj.getItemInHand(ajk);
        bjw.playSound(null, ayj.getX(), ayj.getY(), ayj.getZ(), SoundEvents.EGG_THROW, SoundSource.PLAYERS, 0.5f, 0.4f / (EggItem.random.nextFloat() * 0.4f + 0.8f));
        if (!bjw.isClientSide) {
            final ThrownEgg azg6 = new ThrownEgg(bjw, ayj);
            azg6.setItem(ben5);
            azg6.shootFromRotation(ayj, ayj.xRot, ayj.yRot, 0.0f, 1.5f, 1.0f);
            bjw.addFreshEntity(azg6);
        }
        ayj.awardStat(Stats.ITEM_USED.get(this));
        if (!ayj.abilities.instabuild) {
            ben5.shrink(1);
        }
        return InteractionResultHolder.<ItemStack>success(ben5);
    }
}
