package net.minecraft.world.item;

import net.minecraft.stats.Stat;
import net.minecraft.stats.Stats;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.ThrownEnderpearl;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;

public class EnderpearlItem extends Item {
    public EnderpearlItem(final Properties a) {
        super(a);
    }
    
    @Override
    public InteractionResultHolder<ItemStack> use(final Level bjw, final Player ayj, final InteractionHand ajk) {
        final ItemStack ben5 = ayj.getItemInHand(ajk);
        bjw.playSound(null, ayj.getX(), ayj.getY(), ayj.getZ(), SoundEvents.ENDER_PEARL_THROW, SoundSource.NEUTRAL, 0.5f, 0.4f / (EnderpearlItem.random.nextFloat() * 0.4f + 0.8f));
        ayj.getCooldowns().addCooldown(this, 20);
        if (!bjw.isClientSide) {
            final ThrownEnderpearl azh6 = new ThrownEnderpearl(bjw, ayj);
            azh6.setItem(ben5);
            azh6.shootFromRotation(ayj, ayj.xRot, ayj.yRot, 0.0f, 1.5f, 1.0f);
            bjw.addFreshEntity(azh6);
        }
        ayj.awardStat(Stats.ITEM_USED.get(this));
        if (!ayj.abilities.instabuild) {
            ben5.shrink(1);
        }
        return InteractionResultHolder.<ItemStack>success(ben5);
    }
}
