package net.minecraft.world.item;

import net.minecraft.stats.Stat;
import net.minecraft.stats.Stats;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.ThrownPotion;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;

public class ThrowablePotionItem extends PotionItem {
    public ThrowablePotionItem(final Properties a) {
        super(a);
    }
    
    @Override
    public InteractionResultHolder<ItemStack> use(final Level bjw, final Player ayj, final InteractionHand ajk) {
        final ItemStack ben5 = ayj.getItemInHand(ajk);
        if (!bjw.isClientSide) {
            final ThrownPotion azj6 = new ThrownPotion(bjw, ayj);
            azj6.setItem(ben5);
            azj6.shootFromRotation(ayj, ayj.xRot, ayj.yRot, -20.0f, 0.5f, 1.0f);
            bjw.addFreshEntity(azj6);
        }
        ayj.awardStat(Stats.ITEM_USED.get(this));
        if (!ayj.abilities.instabuild) {
            ben5.shrink(1);
        }
        return InteractionResultHolder.<ItemStack>success(ben5);
    }
}
