package net.minecraft.world.level.block;

import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.phys.shapes.VoxelShape;

public class DeadBushBlock extends BushBlock {
    protected static final VoxelShape SHAPE;
    
    protected DeadBushBlock(final Properties c) {
        super(c);
    }
    
    @Override
    public VoxelShape getShape(final BlockState byj, final BlockGetter bjg, final BlockPos fk, final CollisionContext cvq) {
        return DeadBushBlock.SHAPE;
    }
    
    @Override
    protected boolean mayPlaceOn(final BlockState byj, final BlockGetter bjg, final BlockPos fk) {
        final Block bph5 = byj.getBlock();
        return bph5 == Blocks.SAND || bph5 == Blocks.RED_SAND || bph5 == Blocks.TERRACOTTA || bph5 == Blocks.WHITE_TERRACOTTA || bph5 == Blocks.ORANGE_TERRACOTTA || bph5 == Blocks.MAGENTA_TERRACOTTA || bph5 == Blocks.LIGHT_BLUE_TERRACOTTA || bph5 == Blocks.YELLOW_TERRACOTTA || bph5 == Blocks.LIME_TERRACOTTA || bph5 == Blocks.PINK_TERRACOTTA || bph5 == Blocks.GRAY_TERRACOTTA || bph5 == Blocks.LIGHT_GRAY_TERRACOTTA || bph5 == Blocks.CYAN_TERRACOTTA || bph5 == Blocks.PURPLE_TERRACOTTA || bph5 == Blocks.BLUE_TERRACOTTA || bph5 == Blocks.BROWN_TERRACOTTA || bph5 == Blocks.GREEN_TERRACOTTA || bph5 == Blocks.RED_TERRACOTTA || bph5 == Blocks.BLACK_TERRACOTTA || bph5 == Blocks.DIRT || bph5 == Blocks.COARSE_DIRT || bph5 == Blocks.PODZOL;
    }
    
    static {
        SHAPE = Block.box(2.0, 0.0, 2.0, 14.0, 13.0, 14.0);
    }
}
