package net.minecraft.world.level.block;

import net.minecraft.world.item.ItemStack;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.entity.SpawnerBlockEntity;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.BlockGetter;

public class SpawnerBlock extends BaseEntityBlock {
    protected SpawnerBlock(final Properties c) {
        super(c);
    }
    
    @Override
    public BlockEntity newBlockEntity(final BlockGetter bjg) {
        return new SpawnerBlockEntity();
    }
    
    @Override
    public void spawnAfterBreak(final BlockState byj, final Level bjw, final BlockPos fk, final ItemStack ben) {
        super.spawnAfterBreak(byj, bjw, fk, ben);
        final int integer6 = 15 + bjw.random.nextInt(15) + bjw.random.nextInt(15);
        this.popExperience(bjw, fk, integer6);
    }
    
    @Override
    public RenderShape getRenderShape(final BlockState byj) {
        return RenderShape.MODEL;
    }
    
    @Override
    public ItemStack getCloneItemStack(final BlockGetter bjg, final BlockPos fk, final BlockState byj) {
        return ItemStack.EMPTY;
    }
}
