package net.minecraft.world.level.levelgen.carver;

import java.util.BitSet;
import net.minecraft.world.level.biome.Biome;
import net.minecraft.core.BlockPos;
import java.util.function.Function;
import net.minecraft.world.level.chunk.ChunkAccess;
import java.util.Random;

public class ConfiguredWorldCarver<WC extends CarverConfiguration> {
    public final WorldCarver<WC> worldCarver;
    public final WC config;
    
    public ConfiguredWorldCarver(final WorldCarver<WC> cco, final WC cch) {
        this.worldCarver = cco;
        this.config = cch;
    }
    
    public boolean isStartChunk(final Random random, final int integer2, final int integer3) {
        return this.worldCarver.isStartChunk(random, integer2, integer3, this.config);
    }
    
    public boolean carve(final ChunkAccess bzy, final Function<BlockPos, Biome> function, final Random random, final int integer4, final int integer5, final int integer6, final int integer7, final int integer8, final BitSet bitSet) {
        return this.worldCarver.carve(bzy, function, random, integer4, integer5, integer6, integer7, integer8, bitSet, this.config);
    }
}
