package net.minecraft.world.level.levelgen.feature;

import net.minecraft.world.level.levelgen.feature.configurations.FeatureConfiguration;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.levelgen.ChunkGeneratorSettings;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;
import net.minecraft.world.level.levelgen.feature.configurations.SimpleBlockConfiguration;

public class SimpleBlockFeature extends Feature<SimpleBlockConfiguration> {
    public SimpleBlockFeature(final Function<Dynamic<?>, ? extends SimpleBlockConfiguration> function) {
        super(function);
    }
    
    @Override
    public boolean place(final LevelAccessor bjx, final ChunkGenerator<? extends ChunkGeneratorSettings> caa, final Random random, final BlockPos fk, final SimpleBlockConfiguration chg) {
        if (chg.placeOn.contains(bjx.getBlockState(fk.below())) && chg.placeIn.contains(bjx.getBlockState(fk)) && chg.placeUnder.contains(bjx.getBlockState(fk.above()))) {
            bjx.setBlock(fk, chg.toPlace, 2);
            return true;
        }
        return false;
    }
}
