package net.minecraft.world.level.levelgen.flat;

import net.minecraft.core.Registry;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.BlockState;

public class FlatLayerInfo {
    private final BlockState blockState;
    private final int height;
    private int start;
    
    public FlatLayerInfo(final int integer, final Block bph) {
        this.height = integer;
        this.blockState = bph.defaultBlockState();
    }
    
    public int getHeight() {
        return this.height;
    }
    
    public BlockState getBlockState() {
        return this.blockState;
    }
    
    public int getStart() {
        return this.start;
    }
    
    public void setStart(final int integer) {
        this.start = integer;
    }
    
    @Override
    public String toString() {
        return ((this.height != 1) ? (this.height + "*") : "") + Registry.BLOCK.getKey(this.blockState.getBlock());
    }
}
