package net.minecraft.world.level.levelgen.placement;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import net.minecraft.world.level.levelgen.Heightmap;
import java.util.stream.IntStream;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.levelgen.ChunkGeneratorSettings;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;

public class CountWithExtraChanceHeightmapDecorator extends FeatureDecorator<FrequencyWithExtraChanceDecoratorConfiguration> {
    public CountWithExtraChanceHeightmapDecorator(final Function<Dynamic<?>, ? extends FrequencyWithExtraChanceDecoratorConfiguration> function) {
        super(function);
    }
    
    @Override
    public Stream<BlockPos> getPositions(final LevelAccessor bjx, final ChunkGenerator<? extends ChunkGeneratorSettings> caa, final Random random, final FrequencyWithExtraChanceDecoratorConfiguration cke, final BlockPos fk) {
        int integer7 = cke.count;
        if (random.nextFloat() < cke.extraChance) {
            integer7 += cke.extraCount;
        }
        final int integer8;
        final int integer9;
        final int integer10;
        return IntStream.range(0, integer7).<BlockPos>mapToObj(integer -> {
            integer8 = random.nextInt(16) + fk.getX();
            integer9 = random.nextInt(16) + fk.getZ();
            integer10 = bjx.getHeight(Heightmap.Types.MOTION_BLOCKING, integer8, integer9);
            return new BlockPos(integer8, integer10, integer9);
        });
    }
}
