package net.minecraft.data.loot;

import net.minecraft.world.level.storage.loot.entries.LootPoolSingletonContainer;
import net.minecraft.world.effect.MobEffects;
import net.minecraft.world.level.storage.loot.functions.SetStewEffectFunction;
import net.minecraft.world.level.saveddata.maps.MapDecoration;
import net.minecraft.world.level.storage.loot.functions.ExplorationMapFunction;
import net.minecraft.world.level.storage.loot.functions.EnchantWithLevelsFunction;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.storage.loot.functions.SetItemCountFunction;
import net.minecraft.world.level.storage.loot.RandomValueBounds;
import net.minecraft.world.level.storage.loot.entries.EmptyLootItem;
import net.minecraft.world.level.storage.loot.functions.LootItemFunction;
import net.minecraft.world.level.storage.loot.functions.EnchantRandomlyFunction;
import net.minecraft.world.level.storage.loot.entries.LootPoolEntryContainer;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.storage.loot.entries.LootItem;
import net.minecraft.world.item.Items;
import net.minecraft.world.level.storage.loot.RandomIntGenerator;
import net.minecraft.world.level.storage.loot.ConstantIntValue;
import net.minecraft.world.level.storage.loot.LootPool;
import net.minecraft.world.level.storage.loot.BuiltInLootTables;
import net.minecraft.world.level.storage.loot.LootTable;
import net.minecraft.resources.ResourceLocation;
import java.util.function.BiConsumer;
import java.util.function.Consumer;

public class ChestLoot implements Consumer<BiConsumer<ResourceLocation, LootTable.Builder>> {
    @Override
    public void accept(final BiConsumer<ResourceLocation, LootTable.Builder> biConsumer) {
        biConsumer.accept(BuiltInLootTables.ABANDONED_MINESHAFT, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(1)).add(LootItem.lootTableItem(Items.GOLDEN_APPLE).setWeight(20)).add(LootItem.lootTableItem(Items.ENCHANTED_GOLDEN_APPLE)).add(LootItem.lootTableItem(Items.NAME_TAG).setWeight(30)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BOOK).setWeight(10)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment())).add(LootItem.lootTableItem(Items.IRON_PICKAXE).setWeight(5)).add(EmptyLootItem.emptyItem().setWeight(5))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 4.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.REDSTONE).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 9.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.LAPIS_LAZULI).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 9.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(3.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.MELON_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PUMPKIN_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BEETROOT_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f))))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(3)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.RAIL).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.POWERED_RAIL).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.DETECTOR_RAIL).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.ACTIVATOR_RAIL).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.TORCH).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 16.0f))))));
        biConsumer.accept(BuiltInLootTables.BURIED_TREASURE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(1)).add(LootItem.lootTableItem(Items.HEART_OF_THE_SEA))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(5.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.TNT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f))))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 3.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PRISMARINE_CRYSTALS).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f))))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(0.0f, 1.0f)).add(LootItem.lootTableItem(Items.LEATHER_CHESTPLATE)).add(LootItem.lootTableItem(Items.IRON_SWORD))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(2)).add(LootItem.lootTableItem(Items.COOKED_COD).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f)))).add(LootItem.lootTableItem(Items.COOKED_SALMON).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f))))));
        biConsumer.accept(BuiltInLootTables.DESERT_PYRAMID, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 4.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BONE).setWeight(25)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 6.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.SPIDER_EYE).setWeight(25)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ROTTEN_FLESH).setWeight(25)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(3.0f, 7.0f)))).add(LootItem.lootTableItem(Items.SADDLE).setWeight(20)).add(LootItem.lootTableItem(Items.IRON_HORSE_ARMOR).setWeight(15)).add(LootItem.lootTableItem(Items.GOLDEN_HORSE_ARMOR).setWeight(10)).add(LootItem.lootTableItem(Items.DIAMOND_HORSE_ARMOR).setWeight(5)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BOOK).setWeight(20)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment())).add(LootItem.lootTableItem(Items.GOLDEN_APPLE).setWeight(20)).add(LootItem.lootTableItem(Items.ENCHANTED_GOLDEN_APPLE).setWeight(2)).add(EmptyLootItem.emptyItem().setWeight(15))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(4)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BONE).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GUNPOWDER).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ROTTEN_FLESH).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.STRING).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.SAND).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f))))));
        biConsumer.accept(BuiltInLootTables.END_CITY_TREASURE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 6.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 6.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BEETROOT_SEEDS).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 10.0f)))).add(LootItem.lootTableItem(Items.SADDLE).setWeight(3)).add(LootItem.lootTableItem(Items.IRON_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.GOLDEN_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.DIAMOND_HORSE_ARMOR)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND_SWORD).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND_BOOTS).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND_CHESTPLATE).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND_LEGGINGS).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND_HELMET).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND_PICKAXE).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND_SHOVEL).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_SWORD).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_BOOTS).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_CHESTPLATE).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_LEGGINGS).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_HELMET).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_PICKAXE).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_SHOVEL).setWeight(3)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(RandomValueBounds.between(20.0f, 39.0f)).allowTreasure()))));
        biConsumer.accept(BuiltInLootTables.IGLOO_CHEST, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.APPLE).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_NUGGET).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.STONE_AXE).setWeight(2)).add(LootItem.lootTableItem(Items.ROTTEN_FLESH).setWeight(10)).add(LootItem.lootTableItem(Items.EMERALD)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 3.0f))))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(1)).add(LootItem.lootTableItem(Items.GOLDEN_APPLE))));
        biConsumer.accept(BuiltInLootTables.JUNGLE_TEMPLE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 6.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.BAMBOO).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BONE).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 6.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ROTTEN_FLESH).setWeight(16)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(3.0f, 7.0f)))).add(LootItem.lootTableItem(Items.SADDLE).setWeight(3)).add(LootItem.lootTableItem(Items.IRON_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.GOLDEN_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.DIAMOND_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.BOOK).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(ConstantIntValue.exactly(30)).allowTreasure()))));
        biConsumer.accept(BuiltInLootTables.JUNGLE_TEMPLE_DISPENSER, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 2.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ARROW).setWeight(30)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 7.0f))))));
        biConsumer.accept(BuiltInLootTables.NETHER_BRIDGE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 4.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.GOLDEN_SWORD).setWeight(5)).add(LootItem.lootTableItem(Items.GOLDEN_CHESTPLATE).setWeight(5)).add(LootItem.lootTableItem(Items.FLINT_AND_STEEL).setWeight(5)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.NETHER_WART).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(3.0f, 7.0f)))).add(LootItem.lootTableItem(Items.SADDLE).setWeight(10)).add(LootItem.lootTableItem(Items.GOLDEN_HORSE_ARMOR).setWeight(8)).add(LootItem.lootTableItem(Items.IRON_HORSE_ARMOR).setWeight(5)).add(LootItem.lootTableItem(Items.DIAMOND_HORSE_ARMOR).setWeight(3)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.OBSIDIAN).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f))))));
        biConsumer.accept(BuiltInLootTables.PILLAGER_OUTPOST, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(0.0f, 1.0f)).add(LootItem.lootTableItem(Items.CROSSBOW))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 3.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(7)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(3.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.POTATO).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.CARROT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(3.0f, 5.0f))))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 3.0f)).add(LootItem.lootTableItem(Blocks.DARK_OAK_LOG).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 3.0f))))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 3.0f)).add(LootItem.lootTableItem(Items.EXPERIENCE_BOTTLE).setWeight(7)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.STRING).setWeight(4)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 6.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ARROW).setWeight(4)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.TRIPWIRE_HOOK).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BOOK).setWeight(1)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment()))));
        biConsumer.accept(BuiltInLootTables.SHIPWRECK_MAP, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(1)).add(LootItem.lootTableItem(Items.MAP).apply((LootItemFunction.Builder)ExplorationMapFunction.makeExplorationMap().setDestination("buried_treasure").setMapDecoration(MapDecoration.Type.RED_X).setZoom((byte)1).setSkipKnownStructures(false)))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(3)).add(LootItem.lootTableItem(Items.COMPASS)).add(LootItem.lootTableItem(Items.MAP)).add(LootItem.lootTableItem(Items.CLOCK)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PAPER).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 10.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.FEATHER).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BOOK).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f))))));
        biConsumer.accept(BuiltInLootTables.SHIPWRECK_SUPPLY, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 10.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PAPER).setWeight(8)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 12.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.POTATO).setWeight(7)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 6.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.POISONOUS_POTATO).setWeight(7)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 6.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.CARROT).setWeight(7)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(7)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(8.0f, 21.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.SUSPICIOUS_STEW).setWeight(10)).apply((LootItemFunction.Builder)SetStewEffectFunction.stewEffect().withEffect(MobEffects.NIGHT_VISION, RandomValueBounds.between(7.0f, 10.0f)).withEffect(MobEffects.JUMP, RandomValueBounds.between(7.0f, 10.0f)).withEffect(MobEffects.WEAKNESS, RandomValueBounds.between(6.0f, 8.0f)).withEffect(MobEffects.BLINDNESS, RandomValueBounds.between(5.0f, 7.0f)).withEffect(MobEffects.POISON, RandomValueBounds.between(10.0f, 20.0f)).withEffect(MobEffects.SATURATION, RandomValueBounds.between(7.0f, 10.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ROTTEN_FLESH).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(5.0f, 24.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.PUMPKIN).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.BAMBOO).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GUNPOWDER).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(LootItem.lootTableItem(Blocks.TNT).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.LEATHER_HELMET).setWeight(3)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.LEATHER_CHESTPLATE).setWeight(3)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.LEATHER_LEGGINGS).setWeight(3)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.LEATHER_BOOTS).setWeight(3)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment()))));
        biConsumer.accept(BuiltInLootTables.SHIPWRECK_TREASURE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 6.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(90)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(40)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(LootItem.lootTableItem(Items.DIAMOND).setWeight(5)).add(LootItem.lootTableItem(Items.EXPERIENCE_BOTTLE).setWeight(5))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 5.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_NUGGET).setWeight(50)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 10.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_NUGGET).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 10.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.LAPIS_LAZULI).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 10.0f))))));
        biConsumer.accept(BuiltInLootTables.SIMPLE_DUNGEON, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 3.0f)).add(LootItem.lootTableItem(Items.SADDLE).setWeight(20)).add(LootItem.lootTableItem(Items.GOLDEN_APPLE).setWeight(15)).add(LootItem.lootTableItem(Items.ENCHANTED_GOLDEN_APPLE).setWeight(2)).add(LootItem.lootTableItem(Items.MUSIC_DISC_13).setWeight(15)).add(LootItem.lootTableItem(Items.MUSIC_DISC_CAT).setWeight(15)).add(LootItem.lootTableItem(Items.NAME_TAG).setWeight(20)).add(LootItem.lootTableItem(Items.GOLDEN_HORSE_ARMOR).setWeight(10)).add(LootItem.lootTableItem(Items.IRON_HORSE_ARMOR).setWeight(15)).add(LootItem.lootTableItem(Items.DIAMOND_HORSE_ARMOR).setWeight(5)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BOOK).setWeight(10)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment()))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 4.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(LootItem.lootTableItem(Items.BREAD).setWeight(20)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(LootItem.lootTableItem(Items.BUCKET).setWeight(10)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.REDSTONE).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.MELON_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PUMPKIN_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BEETROOT_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f))))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(3)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BONE).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GUNPOWDER).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ROTTEN_FLESH).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.STRING).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f))))));
        biConsumer.accept(BuiltInLootTables.SPAWN_BONUS_CHEST, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(1)).add(LootItem.lootTableItem(Items.STONE_AXE)).add(LootItem.lootTableItem(Items.WOODEN_AXE).setWeight(3))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(1)).add(LootItem.lootTableItem(Items.STONE_PICKAXE)).add(LootItem.lootTableItem(Items.WOODEN_PICKAXE).setWeight(3))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(3)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.APPLE).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.SALMON).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f))))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(4)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.STICK).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 12.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.OAK_PLANKS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 12.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.OAK_LOG).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.SPRUCE_LOG).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.BIRCH_LOG).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.JUNGLE_LOG).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.ACACIA_LOG).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.DARK_OAK_LOG).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f))))));
        biConsumer.accept(BuiltInLootTables.STRONGHOLD_CORRIDOR, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 3.0f)).add(LootItem.lootTableItem(Items.ENDER_PEARL).setWeight(10)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.REDSTONE).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 9.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.APPLE).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.IRON_PICKAXE).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_SWORD).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_CHESTPLATE).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_HELMET).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_LEGGINGS).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_BOOTS).setWeight(5)).add(LootItem.lootTableItem(Items.GOLDEN_APPLE)).add(LootItem.lootTableItem(Items.SADDLE)).add(LootItem.lootTableItem(Items.IRON_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.GOLDEN_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.DIAMOND_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.BOOK).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(ConstantIntValue.exactly(30)).allowTreasure()))));
        biConsumer.accept(BuiltInLootTables.STRONGHOLD_CROSSING, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 4.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.REDSTONE).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(4.0f, 9.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(3.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.APPLE).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.IRON_PICKAXE)).add(LootItem.lootTableItem(Items.BOOK).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(ConstantIntValue.exactly(30)).allowTreasure()))));
        biConsumer.accept(BuiltInLootTables.STRONGHOLD_LIBRARY, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 10.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BOOK).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PAPER).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 7.0f)))).add(LootItem.lootTableItem(Items.MAP)).add(LootItem.lootTableItem(Items.COMPASS)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BOOK).setWeight(10)).apply((LootItemFunction.Builder)EnchantWithLevelsFunction.enchantWithLevels(ConstantIntValue.exactly(30)).allowTreasure()))));
        biConsumer.accept(BuiltInLootTables.UNDERWATER_RUIN_BIG, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_NUGGET).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.EMERALD)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 3.0f))))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(1)).add(LootItem.lootTableItem(Items.GOLDEN_APPLE)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BOOK).setWeight(5)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment())).add(LootItem.lootTableItem(Items.LEATHER_CHESTPLATE)).add(LootItem.lootTableItem(Items.GOLDEN_HELMET)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.FISHING_ROD).setWeight(5)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.MAP).setWeight(10)).apply((LootItemFunction.Builder)ExplorationMapFunction.makeExplorationMap().setDestination("buried_treasure").setMapDecoration(MapDecoration.Type.RED_X).setZoom((byte)1).setSkipKnownStructures(false)))));
        biConsumer.accept(BuiltInLootTables.UNDERWATER_RUIN_SMALL, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(2.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(LootItem.lootTableItem(Items.STONE_AXE).setWeight(2)).add(LootItem.lootTableItem(Items.ROTTEN_FLESH).setWeight(5)).add(LootItem.lootTableItem(Items.EMERALD)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 3.0f))))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(1)).add(LootItem.lootTableItem(Items.LEATHER_CHESTPLATE)).add(LootItem.lootTableItem(Items.GOLDEN_HELMET)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.FISHING_ROD).setWeight(5)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment())).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.MAP).setWeight(5)).apply((LootItemFunction.Builder)ExplorationMapFunction.makeExplorationMap().setDestination("buried_treasure").setMapDecoration(MapDecoration.Type.RED_X).setZoom((byte)1).setSkipKnownStructures(false)))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_WEAPONSMITH, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.APPLE).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.IRON_PICKAXE).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_SWORD).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_CHESTPLATE).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_HELMET).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_LEGGINGS).setWeight(5)).add(LootItem.lootTableItem(Items.IRON_BOOTS).setWeight(5)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.OBSIDIAN).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(3.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.OAK_SAPLING).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(3.0f, 7.0f)))).add(LootItem.lootTableItem(Items.SADDLE).setWeight(3)).add(LootItem.lootTableItem(Items.IRON_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.GOLDEN_HORSE_ARMOR)).add(LootItem.lootTableItem(Items.DIAMOND_HORSE_ARMOR))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_TOOLSMITH, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.DIAMOND).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.IRON_PICKAXE).setWeight(5)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.STICK).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.IRON_SHOVEL).setWeight(5))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_CARTOGRAPHER, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 5.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.MAP).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PAPER).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(LootItem.lootTableItem(Items.COMPASS).setWeight(5)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.STICK).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_MASON, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 5.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.CLAY_BALL).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.FLOWER_POT).setWeight(1)).add(LootItem.lootTableItem(Blocks.STONE).setWeight(2)).add(LootItem.lootTableItem(Blocks.STONE_BRICKS).setWeight(2)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(4)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(LootItem.lootTableItem(Items.YELLOW_DYE).setWeight(1)).add(LootItem.lootTableItem(Blocks.SMOOTH_STONE).setWeight(1)).add(LootItem.lootTableItem(Items.EMERALD).setWeight(1))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_ARMORER, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 5.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(4)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(LootItem.lootTableItem(Items.IRON_HELMET).setWeight(1)).add(LootItem.lootTableItem(Items.EMERALD).setWeight(1))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_SHEPHERD, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 5.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.WHITE_WOOL).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.BLACK_WOOL).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.GRAY_WOOL).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.BROWN_WOOL).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.LIGHT_GRAY_WOOL).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.EMERALD).setWeight(1)).add(LootItem.lootTableItem(Items.SHEARS).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 6.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_BUTCHER, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 5.0f)).add(LootItem.lootTableItem(Items.EMERALD).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PORKCHOP).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BEEF).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.MUTTON).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_FLETCHER, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 5.0f)).add(LootItem.lootTableItem(Items.EMERALD).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ARROW).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.FEATHER).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EGG).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.FLINT).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.STICK).setWeight(6)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_FISHER, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 5.0f)).add(LootItem.lootTableItem(Items.EMERALD).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COD).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.SALMON).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WATER_BUCKET).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BARREL).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT_SEEDS).setWeight(3)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_TANNERY, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 5.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.LEATHER).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.LEATHER_CHESTPLATE).setWeight(2)).add(LootItem.lootTableItem(Items.LEATHER_BOOTS).setWeight(2)).add(LootItem.lootTableItem(Items.LEATHER_HELMET).setWeight(2)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(LootItem.lootTableItem(Items.LEATHER_LEGGINGS).setWeight(2)).add(LootItem.lootTableItem(Items.SADDLE).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_TEMPLE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.REDSTONE).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(7)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ROTTEN_FLESH).setWeight(7)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.LAPIS_LAZULI).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_PLAINS_HOUSE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_NUGGET).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.DANDELION).setWeight(2)).add(LootItem.lootTableItem(Items.POPPY).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.POTATO).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.APPLE).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(LootItem.lootTableItem(Items.BOOK).setWeight(1)).add(LootItem.lootTableItem(Items.FEATHER).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.OAK_SAPLING).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_TAIGA_HOUSE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_NUGGET).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(LootItem.lootTableItem(Items.FERN).setWeight(2)).add(LootItem.lootTableItem(Items.LARGE_FERN).setWeight(2)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.POTATO).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.SWEET_BERRIES).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PUMPKIN_SEEDS).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(LootItem.lootTableItem(Items.PUMPKIN_PIE).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.SPRUCE_SAPLING).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(LootItem.lootTableItem(Items.SPRUCE_SIGN).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.SPRUCE_LOG).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_SAVANNA_HOUSE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 8.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_NUGGET).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(LootItem.lootTableItem(Items.GRASS).setWeight(5)).add(LootItem.lootTableItem(Items.TALL_GRASS).setWeight(5)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.ACACIA_SAPLING).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f)))).add(LootItem.lootTableItem(Items.SADDLE).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.TORCH).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 2.0f)))).add(LootItem.lootTableItem(Items.BUCKET).setWeight(1))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_SNOWY_HOUSE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 8.0f)).add(LootItem.lootTableItem(Blocks.BLUE_ICE).setWeight(1)).add(LootItem.lootTableItem(Blocks.SNOW_BLOCK).setWeight(4)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.POTATO).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BEETROOT_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 5.0f)))).add(LootItem.lootTableItem(Items.BEETROOT_SOUP).setWeight(1)).add(LootItem.lootTableItem(Items.FURNACE).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.SNOWBALL).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f))))));
        biConsumer.accept(BuiltInLootTables.VILLAGE_DESERT_HOUSE, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(3.0f, 8.0f)).add(LootItem.lootTableItem(Items.CLAY_BALL).setWeight(1)).add(LootItem.lootTableItem(Items.GREEN_DYE).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.CACTUS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 7.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BREAD).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(LootItem.lootTableItem(Items.BOOK).setWeight(1)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Blocks.DEAD_BUSH).setWeight(2)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.EMERALD).setWeight(1)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 3.0f))))));
        biConsumer.accept(BuiltInLootTables.WOODLAND_MANSION, LootTable.lootTable().withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 3.0f)).add(LootItem.lootTableItem(Items.LEAD).setWeight(20)).add(LootItem.lootTableItem(Items.GOLDEN_APPLE).setWeight(15)).add(LootItem.lootTableItem(Items.ENCHANTED_GOLDEN_APPLE).setWeight(2)).add(LootItem.lootTableItem(Items.MUSIC_DISC_13).setWeight(15)).add(LootItem.lootTableItem(Items.MUSIC_DISC_CAT).setWeight(15)).add(LootItem.lootTableItem(Items.NAME_TAG).setWeight(20)).add(LootItem.lootTableItem(Items.CHAINMAIL_CHESTPLATE).setWeight(10)).add(LootItem.lootTableItem(Items.DIAMOND_HOE).setWeight(15)).add(LootItem.lootTableItem(Items.DIAMOND_CHESTPLATE).setWeight(5)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BOOK).setWeight(10)).apply((LootItemFunction.Builder)EnchantRandomlyFunction.randomApplicableEnchantment()))).withPool(LootPool.lootPool().setRolls(RandomValueBounds.between(1.0f, 4.0f)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.IRON_INGOT).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GOLD_INGOT).setWeight(5)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(LootItem.lootTableItem(Items.BREAD).setWeight(20)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.WHEAT).setWeight(20)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(LootItem.lootTableItem(Items.BUCKET).setWeight(10)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.REDSTONE).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.COAL).setWeight(15)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.MELON_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.PUMPKIN_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BEETROOT_SEEDS).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(2.0f, 4.0f))))).withPool(LootPool.lootPool().setRolls(ConstantIntValue.exactly(3)).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.BONE).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.GUNPOWDER).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.ROTTEN_FLESH).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f)))).add(((LootPoolSingletonContainer.Builder<LootPoolEntryContainer.Builder<?>>)LootItem.lootTableItem(Items.STRING).setWeight(10)).apply((LootItemFunction.Builder)SetItemCountFunction.setCount(RandomValueBounds.between(1.0f, 8.0f))))));
    }
}
